/*
 * Copyright 2004-2006 Graeme Rocher
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.codehaus.groovy.grails.orm.support;

import org.springframework.transaction.PlatformTransactionManager;

/**
 * @author Graeme Rocher
 * @since 0.4
 */
public interface TransactionManagerAware {

    /**
     * Sets the transaction manager on implementors
     *
     * @param transactionManager The TransactionManager implementation
     */
    void setTransactionManager(PlatformTransactionManager transactionManager);
}
